﻿using System;
using Wisej.Web;


namespace Wisej.GoogleMaps
{
	public partial class MapPage : Page
	{
		public MapPage()
		{
			InitializeComponent();
			this.googleMap1.MarkerDragEnd += GoogleMap1_MarkerDragEnd;

		}

		private void GoogleMap1_MarkerDragEnd(object sender, Web.Ext.GoogleMaps.MarkerDragEventArgs e)
		{
		}

		private void checkBoxMapType_CheckedChanged(object sender, EventArgs e)
		{
			this.googleMap1.Options.mapTypeControl = this.checkBoxMapType.Checked;
			this.googleMap1.Update();
		}

		private void checkBoxZoom_CheckedChanged(object sender, EventArgs e)
		{
			this.googleMap1.Options.zoomControl = this.checkBoxZoom.Checked;
			this.googleMap1.Update();
		}

		private void checkBoxFullScreen_CheckedChanged(object sender, EventArgs e)
		{
			this.googleMap1.Options.fullscreenControl = this.checkBoxFullScreen.Checked;
			this.googleMap1.Update();
		}

		private void StreetView_CheckedChanged(object sender, EventArgs e)
		{
			this.googleMap1.Options.streeViewControl = this.checkBoxStreetView.Checked;
			this.googleMap1.Update();
		}

		private void checkedListBoxMapType_AfterItemCheck(object sender, ItemCheckEventArgs e)
		{
			string[] ids = new string[this.checkedListBoxMapType.CheckedItems.Count];
			for (int i = 0; i < ids.Length; i++)
			{
				ids[i] = this.checkedListBoxMapType.CheckedItems[i].ToString().ToLowerInvariant();
			}

			this.googleMap1.Update();
		}

		private void numericUpDownMinZoom_ValueChanged(object sender, EventArgs e)
		{
			this.googleMap1.Options.minZoom = this.numericUpDownMinZoom.Value;
			this.googleMap1.Update();
		}

		private void numericUpDownMaxZoom_ValueChanged(object sender, EventArgs e)
		{
			this.googleMap1.Options.maxZoom = this.numericUpDownMaxZoom.Value;
			this.googleMap1.Update();
		}

		private void trackBar1_ValueChanged(object sender, EventArgs e)
		{
			this.googleMap1.Options.zoom = this.trackBar1.Value;
			this.googleMap1.Update();
		}

		private void buttonAddMarker_Click(object sender, EventArgs e)
		{
			if (this.maskedTextBoxID.Text != "")
			{
				this.maskedTextBoxID.Invalid = false;

				if (this.textBoxAddress.Text != "")
				{
					this.googleMap1.AddMarker(this.maskedTextBoxID.Text, this.textBoxAddress.Text.Replace("\r\n", ","), new { draggable = true });
				}
				else
				{
					this.googleMap1.AddMarker(this.maskedTextBoxID.Text, Double.Parse(this.maskedTextBoxLat.Text), Double.Parse(this.maskedTextBoxLng.Text), null);
				}
			}
			else
			{
				this.maskedTextBoxID.Invalid = true;
				MessageBox.Show("Enter the marker's name.", modal: false, icon: MessageBoxIcon.Error);
			}
		}

		private void buttonRemoveMarker_Click(object sender, EventArgs e)
		{
			this.googleMap1.RemoveMarker(this.maskedTextBoxID.Text);
		}

		private void buttonClearMarkers_Click(object sender, EventArgs e)
		{
			this.googleMap1.ClearMarkers();
		}

		private void googleMap1_MapClick(object sender, Web.Ext.GoogleMaps.MapMouseEventArgs e)
		{
			if (e.Marker == null)
				AlertBox.Show("You clicked location: " + e.Location.ToString(), alignment: System.Drawing.ContentAlignment.BottomRight);
			else
				AlertBox.Show("You clicked marker: " + e.Marker + "  at location: " + e.Location.ToString(), alignment: System.Drawing.ContentAlignment.TopRight);

		}

		private void comboBoxMatType_SelectedIndexChanged(object sender, EventArgs e)
		{
			this.googleMap1.Options.mapTypeId = this.comboBoxMapType.Text.ToLowerInvariant();
			this.googleMap1.Update();
		}

		private void MapPage_Load(object sender, EventArgs e)
		{
			this.comboBoxMapType.SelectedIndex = 0;
			this.checkedListBoxMapType.SetItemChecked(0, true);
			this.checkedListBoxMapType.SetItemChecked(1, true);
			this.checkedListBoxMapType.SetItemChecked(2, true);
			this.checkedListBoxMapType.SetItemChecked(3, true);

			// add circles

		}

		private void googleMap1_MapPropertyChanged(object sender, Web.Ext.GoogleMaps.MapPropertyChangedEventArgs e)
		{
			switch (e.Name)
			{
				case "zoom":
					this.trackBar1.Value = (int)e.Value;
					break;
			}
		}

		private void button1_Click(object sender, EventArgs e)
		{
			this.googleMap1.Call("addTestCircles");

			this.googleMap1.Call("addCircle", new {
				strokeColor = "#00FF00",
				strokeOpacity= 0.8,
				strokeWeight= 2,
				fillColor= "#00FF00",
				fillOpacity= 0.35,
				center= new { lat= 41.878, lng= -87.629 }, // Chicago
				radius= Math.Sqrt(2714856) * 100 // Population
			});
		}
	}
}
